Module javafx.graphics
Package javafx.scene.layout

# Class AnchorPane

java.lang.Object
javafx.scene.Node
javafx.scene.Parent
javafx.scene.layout.Region
javafx.scene.layout.Pane
javafx.scene.layout.AnchorPane

All Implemented Interfaces:
  `Styleable`, `EventTarget`

public class AnchorPane extends Pane
AnchorPane allows the edges of child nodes to be anchored to an offset from the anchor pane's edges. If the anchor pane has a border and/or padding set, the offsets will be measured from the inside edge of those insets.

AnchorPane lays out each managed child regardless of the child's visible property value; unmanaged children are ignored for all layout calculations.

AnchorPanes may be styled with backgrounds and borders using CSS. See `Region` superclass for details.

## Anchor Constraints

The application sets anchor constraints on each child to configure the anchors on one or more sides. If a child is anchored on opposite sides (and is resizable), the anchor pane will resize it to maintain both offsets, otherwise the anchor pane will resize it to its preferred size. If in the former case (anchored on opposite sides) and the child is not resizable, then only the top/left anchor will be honored. AnchorPane provides a static method for setting each anchor constraint.

AnchorPane Constraint Table
Constraint | Type | Description
--- | --- | ---
topAnchor | double | distance from the anchor pane's top insets to the child's top edge.
leftAnchor | double | distance from the anchor pane's left insets to the child's left edge.
bottomAnchor | double | distance from the anchor pane's bottom insets to the child's bottom edge.
rightAnchor | double | distance from the anchor pane's right insets to the child's right edge.

AnchorPane Example:

         AnchorPane anchorPane = new AnchorPane();
         // List should stretch as anchorPane is resized
         ListView list = new ListView();
         AnchorPane.setTopAnchor(list, 10.0);
         AnchorPane.setLeftAnchor(list, 10.0);
         AnchorPane.setRightAnchor(list, 65.0);
         // Button will float on right edge
         Button button = new Button("Add");
         AnchorPane.setTopAnchor(button, 10.0);
         AnchorPane.setRightAnchor(button, 10.0);
         anchorPane.getChildren().addAll(list, button);

## Resizable Range

An anchor pane's parent will resize the anchor pane within the anchor pane's resizable range during layout. By default the anchor pane computes this range based on its content as outlined in the table below.

AnchorPane Resize Table
| width | height
minimum | left/right insets plus width required to display children anchored at left/right with at least their min widths | top/bottom insets plus height required to display children anchored at top/bottom with at least their min heights
preferred | left/right insets plus width required to display children anchored at left/right with at least their pref widths | top/bottom insets plus height required to display children anchored at top/bottom with at least their pref heights
maximum | Double.MAX_VALUE | Double.MAX_VALUE

An anchor pane's unbounded maximum width and height are an indication to the parent that it may be resized beyond its preferred size to fill whatever space is assigned to it.

AnchorPane provides properties for setting the size range directly. These properties default to the sentinel value Region.USE_COMPUTED_SIZE, however the application may set them to other values as needed:

         anchorPane.setPrefSize(300, 300);

Applications may restore the computed values by setting these properties back to Region.USE_COMPUTED_SIZE.

AnchorPane does not clip its content by default, so it is possible that children's bounds may extend outside its own bounds if the anchor pane is resized smaller than its preferred size.

Since:
  JavaFX 2.0

- ## Property Summary

  ### Properties declared in class javafx.scene.layout.Region

  `background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

  ### Properties declared in class javafx.scene.Parent

  `needsLayout`

  ### Properties declared in class javafx.scene.Node

  `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, focusVisible, focusWithin, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

- ## Field Summary

  ### Fields declared in class javafx.scene.layout.Region

  `USE_COMPUTED_SIZE, USE_PREF_SIZE`

  ### Fields declared in class javafx.scene.Node

  `BASELINE_OFFSET_SAME_AS_HEIGHT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AnchorPane()`
  Creates an AnchorPane layout.
  `AnchorPane(Node... children)`
  Creates an AnchorPane layout with the given children.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `clearConstraints(Node child)`
  Removes all anchor pane constraints from the child node.
  `static Double`
  `getBottomAnchor(Node child)`
  Returns the child's bottom anchor constraint if set.
  `static Double`
  `getLeftAnchor(Node child)`
  Returns the child's left anchor constraint if set.
  `static Double`
  `getRightAnchor(Node child)`
  Returns the child's right anchor constraint if set.
  `static Double`
  `getTopAnchor(Node child)`
  Returns the child's top anchor constraint if set.
  `static void`
  `setBottomAnchor(Node child, Double value)`
  Sets the bottom anchor for the child when contained by an anchor pane.
  `static void`
  `setLeftAnchor(Node child, Double value)`
  Sets the left anchor for the child when contained by an anchor pane.
  `static void`
  `setRightAnchor(Node child, Double value)`
  Sets the right anchor for the child when contained by an anchor pane.
  `static void`
  `setTopAnchor(Node child, Double value)`
  Sets the top anchor for the child when contained by an anchor pane.

  ### Methods declared in class javafx.scene.layout.Pane

  `getChildren`

  ### Methods declared in class javafx.scene.layout.Region

  `backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, getBackground, getBorder, getClassCssMetaData, getCssMetaData, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isResizable, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

  ### Methods declared in class javafx.scene.Parent

  `getBaselineOffset, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, layoutChildren, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

  ### Methods declared in class javafx.scene.Node

  `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, focusVisibleProperty, focusWithinProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isFocusVisible, isFocusWithin, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.css.Styleable

  `getStyleableNode`

- ## Constructor Details

  - ### AnchorPane

    public AnchorPane()
    Creates an AnchorPane layout.

  - ### AnchorPane

    public AnchorPane(Node... children)
    Creates an AnchorPane layout with the given children.
    Parameters:
      `children` - The initial set of children for this pane.
    Since:
      JavaFX 8.0

- ## Method Details

  - ### setTopAnchor

    public static void setTopAnchor(Node child, Double value)
    Sets the top anchor for the child when contained by an anchor pane. If set, the anchor pane will maintain the child's size and position so that it's top is always offset by that amount from the anchor pane's top content edge. Setting the value to null will remove the constraint.
    Parameters:
      `child` - the child node of an anchor pane
      `value` - the offset from the top of the anchor pane

  - ### getTopAnchor

    public static Double getTopAnchor(Node child)
    Returns the child's top anchor constraint if set.
    Parameters:
      `child` - the child node of an anchor pane
    Returns:
      the offset from the top of the anchor pane or null if no top anchor was set

  - ### setLeftAnchor

    public static void setLeftAnchor(Node child, Double value)
    Sets the left anchor for the child when contained by an anchor pane. If set, the anchor pane will maintain the child's size and position so that it's left is always offset by that amount from the anchor pane's left content edge. Setting the value to null will remove the constraint.
    Parameters:
      `child` - the child node of an anchor pane
      `value` - the offset from the left of the anchor pane

  - ### getLeftAnchor

    public static Double getLeftAnchor(Node child)
    Returns the child's left anchor constraint if set.
    Parameters:
      `child` - the child node of an anchor pane
    Returns:
      the offset from the left of the anchor pane or null if no left anchor was set

  - ### setBottomAnchor

    public static void setBottomAnchor(Node child, Double value)
    Sets the bottom anchor for the child when contained by an anchor pane. If set, the anchor pane will maintain the child's size and position so that it's bottom is always offset by that amount from the anchor pane's bottom content edge. Setting the value to null will remove the constraint.
    Parameters:
      `child` - the child node of an anchor pane
      `value` - the offset from the bottom of the anchor pane

  - ### getBottomAnchor

    public static Double getBottomAnchor(Node child)
    Returns the child's bottom anchor constraint if set.
    Parameters:
      `child` - the child node of an anchor pane
    Returns:
      the offset from the bottom of the anchor pane or null if no bottom anchor was set

  - ### setRightAnchor

    public static void setRightAnchor(Node child, Double value)
    Sets the right anchor for the child when contained by an anchor pane. If set, the anchor pane will maintain the child's size and position so that it's right is always offset by that amount from the anchor pane's right content edge. Setting the value to null will remove the constraint.
    Parameters:
      `child` - the child node of an anchor pane
      `value` - the offset from the right of the anchor pane

  - ### getRightAnchor

    public static Double getRightAnchor(Node child)
    Returns the child's right anchor constraint if set.
    Parameters:
      `child` - the child node of an anchor pane
    Returns:
      the offset from the right of the anchor pane or null if no right anchor was set

  - ### clearConstraints

    public static void clearConstraints(Node child)
    Removes all anchor pane constraints from the child node.
    Parameters:
      `child` - the child node